package com.tew.presentation;


import java.io.Serializable;
import java.util.Map;

import javax.faces.bean.*;
import javax.faces.context.FacesContext;

import com.tew.business.LoginService;
import com.tew.infrastructure.Factories;
import com.tew.model.User;


@ManagedBean(name="login")
public class BeanLogin implements Serializable {
	private static final long serialVersionUID = 6L;
	
	private String name = "";
	private String password = "";
	
	public BeanLogin()
	{
		System.out.println("BeanLogin - No existia");
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	
	
	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}



	private String result = "login_form_result_valid";
	
	public String verify() {
		
		LoginService login = Factories.services.createLoginService();
	
		User user = login.verify(name, password);
		if (user != null ){
			putUserInSession(user);
			return "success";
		}
		
		setResult("login_form_result_error");
		return "login";		
	}

	private void putUserInSession(User user) {
		Map<String, Object> session = FacesContext.getCurrentInstance()
			.getExternalContext()
			.getSessionMap();

		session.put("LOGGEDIN_USER", user);
	}

	public String getResult() {
		return result;
	}

	public void setResult(String result) {
		this.result = result;
	}
}

